
indexing
   author: "Miron Brezuleanu"
   purpose: "provide an object to manage the message pools; it will %
            %use an idle object to manage message pools; they must be %
            %registered with the main object"
	    
class EE_MAIN 
   
inherit
   GTK_TIMEOUT_IDLE_COMMAND   
   
feature {EE_MESSAGE_POOL}
   
   edget_manager: EE_MAIN is
	 -- singleton creator - the only _VALID_ way to create this 
	 -- kind of object
      once
	 !!Result
	 Result.init
      end
   
   register(emp: EE_MESSAGE_POOL) is
	 -- will register emp with this idle
      do
	 pools.add_last(emp)
      end      
   
feature
   
   init is
	 -- this will initialize this idle object
      do
	 !ARRAY[EE_MESSAGE_POOL]!pools.make(1, 0)
	 idle := Void	 
      end
   
   start_idling is
	 -- will start the idle calls
      do
	 if idle = Void then
	    !!idle.make(Current, 0)
	 end
      end
   
   pools: COLLECTION[EE_MESSAGE_POOL]
   
   execute(d: ANY):BOOLEAN is
	 -- will give all message pools a chance to process some
	 -- messages
      local
	 i: INTEGER
      do
	 from
	    i := pools.lower
	 until
	    i > pools.upper
	 loop
	    pools.item(i).run
	    Result := Result or pools.item(i).run_result
	    i := i + 1
	 end	 
	 if not Result then
	    idle := Void
	 end
      end
   
   idle: GTK_IDLE
   
end
   
