#include <gdk/gdk.h>

/* modified these macros to make them a little bit more general */
/* I don't know if the kludge with the double `#' is portable, but it works for
   gcc (actually egcs) and these are pretty portable, so it doesn't really matter */

#define DOUBLE_EVENT(type, type2, name) \
double ext_event_##type##_##name(GdkEvent##type2 *event) {\
  return event->##name;\
}

#define INT_EVENT(type, type2, name) \
int ext_event_##type##_##name(GdkEvent##type2 *event) {\
  return event->##name;\
}

#define PCHAR_EVENT(type, type2, name) \
char * ext_event_##type##_##name(GdkEvent##type2 *event) {\
  return event->##name;\
}

/* button event stuff */

DOUBLE_EVENT(button, Button, x)     
DOUBLE_EVENT(button, Button, y)
DOUBLE_EVENT(button, Button, pressure)
DOUBLE_EVENT(button, Button, xtilt)
DOUBLE_EVENT(button, Button, ytilt)
DOUBLE_EVENT(button, Button, x_root)
DOUBLE_EVENT(button, Button, y_root)
     
INT_EVENT(button, Button, time)
INT_EVENT(button, Button, state)
INT_EVENT(button, Button, button)
INT_EVENT(button, Button, source)
INT_EVENT(button, Button, deviceid)

/* motion event stuff - just as the button, only is_hint added */

INT_EVENT(motion, Motion, is_hint)
     
/* key event stuff */

INT_EVENT(key, Key, time)
INT_EVENT(key, Key, state)
INT_EVENT(key, Key, keyval)
INT_EVENT(key, Key, length)
PCHAR_EVENT(key, Key, string)
     
     /* crossing event stuff -- I don't know what this is, I don't need it, I don't wrap
	it for now !*/
     
     /* focus -- I assume `in' true means I get focus, false I lose focus */
     
INT_EVENT(focus, Focus, in)
     
     /* expose event */
     /* because of stupid wrapping of coordinates inside area */

#define EXPOSE_INT_EVENT(type, type2, name, name2) \
int ext_event_##type##_##name2(GdkEvent##type2 *event) {\
  return event->##name;\
}
     
     EXPOSE_INT_EVENT(expose, Expose, area.x, x)
     EXPOSE_INT_EVENT(expose, Expose, area.y, y)
     EXPOSE_INT_EVENT(expose, Expose, area.width, width)
     EXPOSE_INT_EVENT(expose, Expose, area.height,height)


	 INT_EVENT(expose, Expose, count)
     
     /* configure event */
     
     INT_EVENT(configure, Configure, x)
     INT_EVENT(configure, Configure, y)
     INT_EVENT(configure, Configure, width)
     INT_EVENT(configure, Configure, height)
     

	/* these are all the events I'm interested in for now; PJ and FP were interested only
	   in button_event -- so I guess the idea is: you need it, you do the wrapping */

