indexing
   description: "gdk gc"
   status: "You may be able to redistribute and/or modify this program.% 
   % See the README for details."
   copyright: "Copyright (C) 1999 Paul C. Janzen"
   author: "Paul C. Janzen"
   id: "$Id: gdk_gc.e,v 1.5 1999/01/18 19:54:55 pcj Exp $"

	 -- modified by Miron Brezuleanu, 1999/03/13
	 -- it's no longer a placeholder, it's actually useful!

	 -- modified by Miron, 1999/03/21
	 -- added support for separate setting of line attributes
	 
class GDK_GC
inherit 
   GDK_OBJECT
   GTK_CONSTANTS
   EXG_CONSTANTS

creation
   make_default, 
   exg_create,
   make
   
feature

   make(drawable: GDK_DRAWABLE_WRAPPER) is
	 -- creates a new gc and inits some values
      do
	 if not drawable.drawable_is_computed then
	    gdkobject := ext_gc_new(drawable.internal_to_drawable.to_external)
	 else
	    gdkobject := ext_gc_new(drawable.drawable.to_external)
	 end
	 function := gdk_copy
	 foreground := exg_white
	 background := exg_black
      end
      
--   make(w: GTK_WIDGET) is
	 -- inits this to the values of the black gc (hopefully)
--      do
--	 gdkobject := ext_gc_new(w.window.to_external)
--	 function := gdk_copy
--	 foreground := exg_white
--	 background := exg_black
--      end

   destroy is
      do
	 ext_gc_destroy(gdkobject)
      end

   set_foreground(c: GDK_COLOR) is
	 -- routine to set the `ink' color
      do 
	 ext_gc_set_foreground(gdkobject, c.to_external)
	 foreground := c
      end
	 
   set_background(c: GDK_COLOR) is
	 -- routine to set the `paper' color
      do 
	 ext_gc_set_background(gdkobject, c.to_external)
	 background := c
      end

   set_font(f: GDK_FONT) is
	 -- routine to set the `font'
      do
	 ext_gc_set_font(gdkobject, f.to_external)
      end
	 
   set_function(f: GDK_FUNCTION) is
	 -- routine to set the drawing logical function
      do
	 ext_gc_set_function(gdkobject, f.value)
	 function := f
      end
	 
   set_fill(f: GDK_FILL) is
	 -- routine to set the fill strategy
      do
	 ext_gc_set_fill(gdkobject, f.value)
      end
	 
   set_tile(p: GDK_PIXMAP) is
	 -- routine to set the tile pixmap
      do
	 ext_gc_set_tile(gdkobject, p.to_external)
      end
	 
   set_stipple(p: GDK_PIXMAP) is
	 -- routine to set the stipple pixmap
      do
	 ext_gc_set_stipple(gdkobject, p.to_external)
      end
	 
   set_ts_origin(x, y: INTEGER) is
	 -- routine to set the ts (what's ts?!?) origin
      do
	 ext_gc_set_ts_origin(gdkobject, x, y)
      end
	 
   set_clip_origin(x, y: INTEGER) is
	 -- routine to set the clip origin
      do
	 ext_gc_set_clip_origin(gdkobject, x, y)
      end
	 
   set_clip_mask(m: GDK_BITMAP) is
	 -- routine to set the clip mask
      local
	 p: POINTER
      do
	 if m = Void then
	    p := default_pointer
	 else
	    p := m.to_external
	 end
	 ext_gc_set_clip_mask(gdkobject, p)
      end
   
   set_clip_rectangle(r: GDK_RECTANGLE) is
	 -- routine to set the clipping rectangle
      do
	 if r /= Void then
	    ext_gc_set_clip_rectangle(gdkobject, r.to_external)
	 else
	    ext_gc_set_clip_rectangle(gdkobject, default_pointer)
	 end
      end

   set_clip_region(r: GDK_REGION) is
	 -- routine to set the clipping region
      do
	 ext_gc_set_clip_region(gdkobject, r.to_external)
      end

   set_subwindow(m: GDK_SUBWINDOW_MODE) is
	 -- set the subwindow clipping
      do
	 ext_gc_set_subwindow(gdkobject, m.value)
      end

   set_exposures(e: INTEGER) is
	 -- set the exposures (what are these?)
      do
	 ext_gc_set_exposures(gdkobject, e)
      end

   set_line_width(w: INTEGER) is
	 -- only modifies the line width
      require
	 w > 0
      do
	 fill_in_line_attributes
	 line_width := w
	 set_line_attributes_now
      end
   
   set_line_style(ls: GDK_LINE_STYLE) is
	 -- only modifies the line style
      require
	 ls /= Void
      do
	 fill_in_line_attributes
	 line_style := ls
	 set_line_attributes_now
      end

   set_line_cap_style(cs: GDK_CAP_STYLE) is
	 -- only modifies the line cap style (whatever that is)
      require
	 cs /= Void
      do
	 fill_in_line_attributes
	 line_cap_style := cs
	 set_line_attributes_now
      end

   set_line_join_style(js: GDK_JOIN_STYLE) is
	 -- only modifies the line join style (whatever that is)
      require
	 js /= Void
      do
	 fill_in_line_attributes
	 line_join_style := js
	 set_line_attributes_now
      end

   set_line_attributes(w: INTEGER;
		       ls: GDK_LINE_STYLE;
		       cs: GDK_CAP_STYLE;
		       js: GDK_JOIN_STYLE) is
	 -- sets the way lines are drawn (the pen settings?)
	 -- used to do a full `fill in'
      require
	 line_width > 0
	 line_style /= Void
	 line_cap_style /= Void
	 line_join_style /= Void
      do
	 line_width := w
	 line_style := ls
	 line_cap_style := cs
	 line_join_style := js
	 set_line_attributes_now
      end

feature { NONE } -- private helper commands

   set_line_attributes_now is
	 -- does the actual call
      require
	 line_width > 0
	 line_style /= Void
	 line_cap_style /= Void
	 line_join_style /= Void
      do
	 ext_gc_set_line_attributes(gdkobject, line_width,
				    line_style.value, 
				    line_cap_style.value, 
				    line_join_style.value)
      end

   fill_in_line_attributes is
	 -- routine to fill in missing line attributes values
      do
	 if line_width = 0 then line_width := 1 end
	 if line_style = Void then line_style := gdk_line_solid end
	 if line_cap_style = Void then line_cap_style := gdk_cap_not_last end
	 if line_join_style = Void then line_join_style := gdk_join_miter end
      ensure
	 line_width > 0
	 line_style /= Void
	 line_cap_style /= Void
	 line_join_style /= Void
      end
   
feature -- line attributes, etc

   line_width: INTEGER
   line_style: GDK_LINE_STYLE
   line_cap_style: GDK_CAP_STYLE
   line_join_style: GDK_JOIN_STYLE

   function: GDK_FUNCTION
   foreground, background: GDK_COLOR
   
feature { NONE } 
   
   ext_gc_set_foreground(p, c: POINTER) is
      external "C"
      alias "gdk_gc_set_foreground"
      end

   ext_gc_set_background(p, c: POINTER) is
      external "C"
      alias "gdk_gc_set_background"
      end

   ext_gc_set_font(p, f: POINTER) is
      external "C"
      alias "gdk_gc_set_font"
      end

   ext_gc_set_function(p: POINTER; f: INTEGER) is
      external "C"
      alias "gdk_gc_set_function"
      end

   ext_gc_set_fill(p: POINTER; f: INTEGER) is
      external "C"
      alias "gdk_gc_set_fill"
      end

   ext_gc_set_tile(p, t: POINTER) is
      external "C"
      alias "gdk_gc_set_tile"
      end

   ext_gc_set_stipple(p, s: POINTER) is
      external "C"
      alias "gdk_gc_set_stipple"
      end

   ext_gc_set_ts_origin(p: POINTER; x, y: INTEGER) is
      external "C"
      alias "gdk_gc_set_ts_origin"
      end

   ext_gc_set_clip_origin(p: POINTER; x, y: INTEGER) is
      external "C"
      alias "gdk_gc_set_clip_origin"
      end

   ext_gc_set_clip_mask(p, b: POINTER) is
      external "C"
      alias "gdk_gc_set_clip_mask"
      end

   ext_gc_set_clip_rectangle(p, r: POINTER) is
      external "C"
      alias "gdk_gc_set_clip_rectangle"
      end

   ext_gc_set_clip_region(p, r: POINTER) is
      external "C"
      alias "gdk_gc_set_clip_region"
      end

   ext_gc_set_subwindow(p: POINTER; m: INTEGER) is
      external "C"
      alias "gdk_gc_set_subwindow"
      end

   ext_gc_set_exposures(p: POINTER; m: INTEGER) is
      external "C"
      alias "gdk_gc_set_exposures"
      end

   ext_gc_set_line_attributes(p: POINTER; w, ls, cs, js: INTEGER) is
      external "C"
      alias "gdk_gc_set_line_attributes"
      end


   -- this dash thing is more complicated - later
   --   ext_gc_set_dashes(p: POINTER)

   ext_gc_copy(p1, p2: POINTER) is
      external "C"
      alias "gdk_gc_copy"
      end

   ext_gc_destroy(p1: POINTER) is
      external "C"
      alias "gdk_gc_destroy"
      end

   ext_gc_unref(p1: POINTER) is
      external "C"
      alias "gdk_gc_unref"
      end

   ext_gc_new(p1: POINTER): POINTER is
      external "C"
      alias "gdk_gc_new"
      end

invariant
end -- GDK_GC
