
class POPUP_WINDOW_CANVAS
   
inherit
   GTK_DRAWING_AREA
      redefine
	 make,
	 expose_handler,
	 button_1_release_handler
      end
   EXG_CONSTANTS -- to get access to the predefined fonts
   
creation
   make
   
feature
   
   make is
	 -- this sets up stuff -- suggestions for a better comment?
      do
	 Precursor 
	 -- calling the `Precursor' to do some of the work; we don't
	 -- mean to replace the `make' command, but enhance it
	 
	 activate_event_handling
	 -- this is quite important; without this line, the 
	 -- polimorphic event handlers wouldn't work
	 
	 set_size (200, 100)
	 -- we'd like to be exactly that size
      end
   
   expose_handler (r: GDK_RECTANGLE) is
      local
	 gc: GDK_GC
      do
	 !! gc.make (Current) 
	 -- creating the GC (we need one for any drawing)
	 
	 gc.set_foreground (exg_white)
	 draw_rectangle (gc, True, 
			 0, 0, allocation.width, allocation.height)
	 -- clearing the content of the window to white. `allocation' 
	 -- is used to determine the size of the window
	 
	 gc.set_foreground (exg_black)
	 draw_centered_string (exg_h4_font, gc, 100, 50, "Click to close!")
	 -- the actual drawing; notice the `set_foreground' call - 
	 -- without it the string would be quite invisible
	 
	 gc.destroy -- destroying the GC - this is _MANDATORY_
      end
   
   button_1_release_handler (event: GDK_EVENT_BUTTON) is
	 -- will close the window containing this one
      do
	 parent.destroy
      end
   
end

