
indexing
   purpose: "define the widget that provides a modified%
   %rubber band selection"
   author: "Miron Brezuleanu"
   
class RS_CANVAS

inherit 
   GTK_DRAWING_AREA
      redefine
	 make,
	 expose_handler,
	 button_1_press_handler,
	 button_1_release_handler,
	 button_2_release_handler,
	 button_3_release_handler,
	 motion_notify_handler,
	 key_release_handler
      end
   EXG_CONSTANTS
   GTK_CONSTANTS
   
creation
   make
   
feature
   
   make is
	 -- sets things up
      do
	 Precursor
	 set_size (200, 200)
	 activate_event_handling
	 selection := Void
	 step := 0
	 dragging := False
      end
   
   draw_background is
	 -- if you want to use this class in your programs, you can 
	 -- just inherit it and redefine this command, which draws 
	 -- the background under the selection
      
	 -- now it draws just a white background
      local
	 gc: GDK_GC
      do
	 !! gc.make (Current)
	 gc.set_foreground (exg_white)
	 draw_rectangle (gc, True, 
			 0, 0, 
			 allocation.width, allocation.height)
	 gc.destroy
      end
   
   expose_handler (r: GDK_RECTANGLE) is
	 -- redraws the canvas
      local
	 gc: GDK_GC
      do
	 draw_background
	 !! gc.make (Current)
	 gc.destroy
      end
   
   button_1_press_handler (eb: GDK_EVENT_BUTTON) is
	 -- handles the creation & modification of the selection
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
   button_1_release_handler (eb: GDK_EVENT_BUTTON) is
	 -- handles the creation & modification of the selection
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
   button_2_release_handler (eb: GDK_EVENT_BUTTON) is
	 -- displays the current selection (if there is one)
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
   button_3_release_handler (eb: GDK_EVENT_BUTTON) is
	 -- displays the current selection (if there is one)
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
   motion_notify_handler (em: GDK_EVENT_MOTION) is
	 -- handles the creation & modification of the selection
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
   key_release_handler (ek: GDK_EVENT_KEY) is
	 -- handles the creation & modification of the selection
      do
	 inspect step
	 when 0 then
	 when 1 then
	 when 2 then
	 end
      end
   
feature -- queries & attributes
   
   selection: RUBBER_BAND_SELECTION
	 -- the selection object
   
   step: INTEGER
	 -- if 0: we don't have a selection; if 1: we have a normal
	 -- rubber band selection (dragging phase); if 2: we're
	 -- modifying the position of individual points
   
   dragging: BOOLEAN
	 -- `True' if we are dragging something
   
   p1, p2: GDK_POINT
	 -- the corners used during `step=1'
   
end
