
indexing
   author: "Miron Brezuleanu"
   purpose: "implement a stack structure"

class EXG_STACK[G]

inherit
   ARRAY[G]
   
creation
   make_stack
   
feature -- commands
   
   make_stack is 
	 -- creation of the stack
      do
	 make(0, 9)
	 clear
	 top_of_stack := 0
      end

   clone_and_push(data: G) is
	 -- the `push' operation; the item is cloned
      do
	 add_last(clone(data))
	 top_of_stack := top_of_stack + 1
      end

   push(data: G) is
	 -- the `push' operation; the item is not cloned
      do
	 add_last(clone(data))
	 top_of_stack := top_of_stack + 1
      end

   pop is
	 -- the `pop' operation; to actually see what's on top use the
	 -- `top' query
      do
	 remove_last
	 top_of_stack := top_of_stack - 1
      end

feature -- Data & Queries

   top: G is
	 -- tells what's on top
      do
	 Result := Current @ (top_of_stack - 1)
      end
   
   top_of_stack: INTEGER
   
end
