
indexing
   author: "Miron Brezuleanu"
   purpose: "the class which should replace GTK_WINDOW in EXG% 
   %and EXG applications; it does much better handling of modals"
   
class EXG_WINDOW
   
inherit
   GTK_WINDOW   
      redefine
	 make,
	 make_with_type,
	 focus_in_handler
      end
   EXG_CONSTANTS
   GTK_CONSTANTS
   
creation
   make,
   make_with_type
   
feature
   
   make is
	 -- the old one, but activates event handling
      do
	 Precursor
	 activate_event_handling
      end
   
   make_with_type(t: GTK_WINDOW_TYPE) is
	 -- the old one, but activates event handling
      do
	 Precursor(t)
	 activate_event_handling
      end   
   
   focus_in_handler is
	 -- if you redefine this you should call Precursor or else 
	 -- you'll lose the improved modal behaviour 
      do
	 if dialog_stack.is_empty then
	    event_result := False
	 elseif not top_modal_is_among_parents then	    
	    dialog_stack.top.raise
	    event_result := True
	 end	    
      end
   
   top_modal_is_among_parents: BOOLEAN is
	 -- the name is also a comment in this case
      local
	 i: INTEGER
	 plist: ARRAY[GTK_WIDGET]
      do
	 from
	    plist := list_of_parents
	    i := plist.upper
	 until
	    i < plist.lower
	 loop
	    if equal(plist.item(i).window, dialog_stack.top.window) then
	       Result := True
	       i := plist.lower
	    end
	    i := i - 1
	 end
      end
   
end

   
   
