
indexing
   author: "Miron Brezuleanu"
   purpose: "do a correct freeing of imlib obtained images"
   
class IMLIB_PIXMAP
   
inherit
   GDK_PIXMAP
      redefine
	 destroy
      end
   
creation
   make_with_imlib
   
feature
   
   make_with_imlib(ii: IMLIB_IMAGE) is   
	 -- will create the pixmap (and its mask) from the data 
	 -- specified by `ii'
      local
	 lpixmap, lmask: POINTER
      do
	 lpixmap := ext_copy_image(ii.to_external)
	 lmask := ext_copy_mask(ii.to_external)
	 if lmask /= default_pointer then
	    create_pixmap(lpixmap, lmask)
	 else
	    gdkobject := lpixmap
	 end
      end
   
   destroy is
      do
	 ext_free_pixmap(gdkobject)
      end
   
feature { NONE } -- external stuff
   
   ext_free_pixmap(p: POINTER) is
      external "C"
      alias "gdk_imlib_free_pixmap"
      end
   
   ext_copy_image(p: POINTER): POINTER is   
      external "C"
      alias "gdk_imlib_copy_image"
      end
   
   ext_copy_mask(p: POINTER): POINTER is
      external "C"
      alias "gdk_imlib_copy_mask"
      end    
   
end
