
class PGEN_PAGE_1_COMMAND

inherit
   GTK_COMMAND
   EXG_CONSTANTS
   EXG_FILE_TOOLS

creation
   make

feature

   make(ppp: PGEN_PAGE_1) is
      do
	 pp := ppp
      end

   pp: PGEN_PAGE_1
   filesel: GTK_FILE_SELECTION

   execute(d: ANY) is
      local
	 ppp: PGEN_PAGE_1
	 ic: INTEGER_REF
	 m: EXG_MESSAGE_BOX
      do
	 ppp ?= d
	 if ppp = pp then
	    !!filesel.make("Select a directory")
	    filesel.signal_connect("destroy", Current, Destroy_filesel)
	    filesel.ok_button.signal_connect("clicked", Current, Filesel_ok)
	    filesel.cancel_button.signal_connect("clicked", Current, 
						 Filesel_cancel)
	    filesel.show	    
	 end
	 ic ?= d
	 if ic /= Void then
	    inspect ic.item
	    when Destroy_filesel then
	       filesel.destroy
	    when Filesel_cancel then
	       filesel.destroy
	    when Filesel_ok then
	       if not is_directory(filesel.filename) then
		  !!m.make
		  m.set_message("You should specify a directory,%N%
				 %not a file!")
		  m.set_pixmap(exg_default_pixmaps.at("exclamation"))
		  m.run
	       else
		  pp.project_path.set_text(filesel.filename)
	       end
	       filesel.destroy
	    end
	 end
      end
feature -- some constants
   
   Destroy_filesel, Filesel_ok, Filesel_cancel: INTEGER is unique

end
   

