
class WIZARD

inherit
   
   EXG_MAIN_WINDOW
      rename
	 make as old_make
      end
   
creation
   make

feature -- creation

   make(ppages: ARRAY[WIZARD_PAGE]) is
      require
	 ppages.count > 0
      local
	 separator: GTK_SEPARATOR
	 i: INTEGER
      do
	 old_make
	 set_policy(True, True, True)
	 !!wizard_command.make(Current)
	 pages := ppages
	 current_page := 1
	 !GTK_VBOX!vbox.make(False, 3)
	 from
	    i := 1
	 until
	    i > pages.count
	 loop
	    vbox.pack_start(pages.item(i), False, False, 0)
	    i := i + 1
	 end
	 pages.item(current_page).wizard_page_enter
	 pages.item(current_page).show
	 !GTK_HSEPARATOR!separator.make
	 vbox.pack_start(separator, False, False, 0)
	 separator.show
	 !GTK_HBOX!bbox.make(False, 0)
	 !!prev_button.make_with_label("Previous")
	 bbox.pack_start(prev_button, False, False, 0)
	 prev_button.signal_connect("clicked", wizard_command, "previous")
	 prev_button.set_sensitive(False)
	 prev_button.show
	 !!next_button.make
	 if pages.count > 1 then
	    !!next_label.make_with_label("Next")
	 else
	    !!next_label.make_with_label("Finish")
	 end
	 next_button.add(next_label)
	 next_label.show
	 bbox.pack_start(next_button, False, False, 0)
	 next_button.signal_connect("clicked", wizard_command, next_label)
	 next_button.show
	 !!cancel_button.make_with_label("Cancel")
	 bbox.pack_start(cancel_button, False, False, 0)
	 cancel_button.signal_connect("clicked", wizard_command, "cancel")
	 cancel_button.show
	 vbox.pack_start(bbox, False, False, 0)
	 !!filler.make
	 bbox.pack_start(filler, True, True, 0)
	 filler.show
	 bbox.show
	 add(vbox)
	 vbox.show
	 signal_connect("destroy", wizard_command, "cancel")
      end
   
feature -- commands

   previous is
      do
	 if current_page > 1 
	    and pages.item(current_page).wizard_page_can_leave then
	    pages.item(current_page).wizard_page_leave
	    pages.item(current_page).hide
	    current_page := current_page - 1
	    pages.item(current_page).wizard_page_enter
	    pages.item(current_page).show
	 end
	 if current_page = 1 then
	    prev_button.set_sensitive(False)
	 end
	 if current_page = pages.count - 1 then
	    next_label.set_text("Next")
	 end
      end

   next is
      do
	 if pages.item(current_page).wizard_page_can_leave then
	    pages.item(current_page).wizard_page_leave
	    pages.item(current_page).hide
	    current_page := current_page + 1
	    pages.item(current_page).wizard_page_enter
	    pages.item(current_page).show
	    prev_button.set_sensitive(True)
	    if current_page = pages.count then
	       next_label.set_text("Finish")
	    end
	 end
      end

   finish is
      local
	 i: INTEGER
      do
	 if pages.item(current_page).wizard_page_can_leave then
	    from
	       i := 1
	    until
	       i > pages.count
	    loop
	       pages.item(i).finish
	       i := i + 1
	    end
	    quit
	 end
      end

   cancel is
      do
	 quit
      end

feature -- queries
feature -- attributes

   prev_button, next_button, cancel_button: GTK_BUTTON   
   next_label: GTK_LABEL
   vbox, bbox: GTK_BOX
   filler: GTK_EVENT_BOX   
   current_page: INTEGER
   pages: ARRAY[WIZARD_PAGE]
   wizard_command: WIZARD_COMMAND

end
   

